from __future__ import annotations

from pydantic import BaseModel, Field


class HistoryRecord(BaseModel):
    release: str
    hash: str
    deployed: str
    released: str
    distros: list[str] | None = None


class UpdatesInfo(BaseModel):
    releases: list[HistoryRecord] = Field(default_factory=list)
    blocked: list[str] = Field(default_factory=list)
    available_products: list[str] = Field(default_factory=list)
    error: str | None = None
