$(document).ready(function() {
    createDoughnutChart('#uptime-distribution-data', '#uptime-distribution-chart', 'Uptime distribution');
    createDoughnutChart('#arch-distribution-data', '#arch-distribution-chart', 'CPU arch distribution');
});


function generateAtLeastFourLabels(chart) { // workaround to adjust legend height
    const labels = Chart.overrides.doughnut.plugins.legend.labels.generateLabels(chart);
    if (labels.length >= 4) {
        return labels;
    }
    var newLabels = Array(4).fill({
        text: ' '.repeat(10),
        datasetIndex: -1,
        fillStyle: 'transparent',
        strokeStyle: 'transparent',
    })

    for (i = 0; i < labels.length; i++) {
        newLabels[Math.floor((4 - labels.length) / 2) + i] = labels[i];
    }

    return newLabels;
}

function createDoughnutChart(dataId, contextId, title) {
    const chartData = JSON.parse($(dataId).text());
    const chart = new Chart($(contextId), {
        type: 'doughnut',
        data: {
            datasets: [{
                data: chartData.data,
                label: 'Servers',
            }],
            labels: chartData.labels,
        },
        options: {
            responsive: false,
            plugins: {
                legend: {
                    display: true,
                    position: 'top',
                    labels: {
                        boxWidth: 30,
                        boxHeight: 10,
                        padding: 5,
                        generateLabels: generateAtLeastFourLabels,
                    },
                },
                title: {
                    display: true,
                    text: title,
                }
            }
        }
    });
}
