from __future__ import annotations

from typing import Callable, TypeVar, Generic, Any
from sqlalchemy.orm import InstrumentedAttribute

T = TypeVar('T')

class BaseSQLAFilter(Generic[T]):
    def __init__(
        self,
        column: str | InstrumentedAttribute[T],
        name: str,
        options: list[tuple] | Callable[[], list[tuple]] | None = None,
    ): ...
    def get_column(self, alias: Any) -> Any: ...

    name: str
    column: Any

class IntGreaterFilter(BaseSQLAFilter): ...
class FilterEqual(BaseSQLAFilter): ...
class FilterLike(BaseSQLAFilter): ...
class DateEqualFilter(BaseSQLAFilter): ...
class DateGreaterFilter(BaseSQLAFilter): ...
class DateSmallerFilter(BaseSQLAFilter): ...
class FilterInList(BaseSQLAFilter): ...
class FilterNotInList(BaseSQLAFilter): ...
